%define anolis_release 2

%global    defaultsanspkg    google-noto-sans-vf-fonts
%global    defaultserifpkg   google-noto-serif-vf-fonts
%global    defaultmonopkg    google-noto-sans-mono-vf-fonts

Name:      langpacks
Version:   3.0
Release:   %{anolis_release}%{?dist}
Summary:   Langpacks meta-package
License:   GPLv2+

Source0:   org.fedoraproject.LangPacks.xml
Source1:   org.fedoraproject.LangPacks-Core.xml
Source2:   org.fedoraproject.LangPacks-Core-Font.xml
Source3:   normlang.py
Source4:   fonts-list

BuildArch: noarch
BuildRequires: libappstream-glib >= 0.5.10 python3 fontconfig

%description
Langpack meta-package to provide individual langpacks packages.

# langcore_pkg (defaultime,defaultfont,langcode,langname)
%define langcore_pkg(i:f:l:n:) \
%define langcode %{-l:%{-l*}}%{!-l:%{error:Language code not defined}} \
%define langname %{-n:%{-n*}}%{!-n:%{error:Language name not defined}} \
%define normcode %{lua:print((string.gsub(string.lower(rpm.expand("%{langcode}")), "_","-")))}\
%define langortho %(python3 %{SOURCE3} %{langcode}) \
%define lowerortho %{lua:print(string.lower(rpm.expand("%{langortho}")))}\
%define fontpkgcode %{lua:print((string.gsub(rpm.expand("%{langortho}"),"-","_")))}\
\
%package core-%{langcode}\
Summary: %{langname} langpacks core meta-package\
Requires: langpacks-core-font-%{fontpkgcode}\
%{-i:Requires: (%{-i*} if xorg-x11-server-Xorg)} \
\
%description core-%{langcode}\
This package provides %{langname} core langpacks packages.\
\
%files core-%{langcode}\
%{_datadir}/metainfo/org.fedoraproject.LangPack-Core-%{langcode}.metainfo.xml\
\
%if "%{normcode}" == "%{lowerortho}"\
%package core-font-%{fontpkgcode}\
Summary: %{langname} core font meta-package\
%{-f:Requires: %{-f*}}%{!-f:Requires: %{defaultsanspkg}} \
%{-l:Provides: font(:lang=%{lowerortho})}  \
%if "%{lowerortho}" != "%{fontpkgcode}"\
Provides: langpacks-core-font-%{lowerortho} = %{version}-%{release} \
Obsoletes: langpacks-core-font-%{lowerortho} < %{version}-%{release} \
%endif \
\
%description core-font-%{fontpkgcode}\
This package defines the default font for %{langname} language.\
\
%files core-font-%{fontpkgcode}\
%{_datadir}/metainfo/org.fedoraproject.LangPack-Core-Font-%{fontpkgcode}.metainfo.xml\
%endif

%package en
Summary: English langpacks meta-package
Requires: %{name}-core-en

%description en
This package provides English langpacks meta-package.

%package en_GB
Summary: English (United Kingdom) langpacks meta-package
Requires: %{name}-core-en_GB

%description en_GB
This package provides English (United Kingdom) langpacks meta-package.


%package zh_CN
Summary: Simplified Chinese langpacks meta-package
Requires: %{name}-core-zh_CN
Recommends: google-noto-serif-cjk-ttc-fonts

%description zh_CN
This package provides Simplified Chinese langpacks meta-package.

%package zh_HK
Summary: Hong Kong Traditional Chinese langpacks meta-package
Requires: %{name}-core-zh_HK
Recommends: google-noto-serif-cjk-ttc-fonts
Recommends: ibus-table-chinese-quick

%description zh_HK
This package provides Hong Kong Traditional Chinese langpacks meta-package.

%package zh_TW
Summary: Taiwan langpacks meta-package
Requires: %{name}-core-zh_TW
Recommends: google-noto-serif-cjk-ttc-fonts
Recommends: ibus-table-chinese-cangjie
Recommends: ibus-table-chinese-quick

%description zh_TW
This package provides Taiwan Traditional Chinese langpacks meta-package.

%prep
# nothing to prep

%build
# nothing to build

%install
mkdir -p %{buildroot}/usr/share/metainfo
DESTDIR=%{buildroot} appstream-util split-appstream %{SOURCE0}
DESTDIR=%{buildroot} appstream-util split-appstream %{SOURCE1}
DESTDIR=%{buildroot} appstream-util split-appstream %{SOURCE2}

# delete useless language packages
for font in $(cat %{SOURCE4}); do
    for dir in LangPack LangPack-Core LangPack-Core-Font; do
        rm -rf %{buildroot}%{_datadir}/metainfo/org.fedoraproject.${dir}-${font}.metainfo.xml
    done
done
rm -rf %{buildroot}%{_datadir}/metainfo/org.fedoraproject.LangPack-Core-pt_BR.metainfo.xml
rm -rf %{buildroot}%{_datadir}/metainfo/org.fedoraproject.LangPack-pt_BR.metainfo.xml


%files en
%{_datadir}/metainfo/org.fedoraproject.LangPack-en.metainfo.xml
%langcore_pkg -l en -n English

%files en_GB
%{_datadir}/metainfo/org.fedoraproject.LangPack-en_GB.metainfo.xml
%langcore_pkg -l en_GB -n %{quote:English (United Kingdom)}

%files zh_CN
%{_datadir}/metainfo/org.fedoraproject.LangPack-zh_CN.metainfo.xml
%langcore_pkg -l zh_CN -n %{quote:Simplified Chinese} -f google-noto-sans-cjk-ttc-fonts -i ibus-libpinyin

%files zh_HK
%{_datadir}/metainfo/org.fedoraproject.LangPack-zh_HK.metainfo.xml
%langcore_pkg -l zh_HK -n %{quote:Hong Kong Traditional Chinese} -f google-noto-sans-cjk-ttc-fonts -i ibus-table-chinese-cangjie

%files zh_TW
%{_datadir}/metainfo/org.fedoraproject.LangPack-zh_TW.metainfo.xml
%langcore_pkg -l zh_TW -n %{quote:Taiwan Traditional Chinese} -f google-noto-sans-cjk-ttc-fonts -i ibus-libzhuyin

%changelog
* Fri Apr 14 2023 yuanhui <yuanhui@linux.alibaba.com> - 3.0-2
- Optimize the spec file

* Fri Mar 18 2022 forrest_ly <flin@linux.alibaba.com> - 3.0-1
- Init for Anolis OS 23
